package rocks.zipcode.io.quiz4.objectorientation;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @author leon on 18/12/2018.
 */
public class PalindromeObject {
    String input;
    public PalindromeObject(String input) {
        this.input = input;
    }

    public String[] getAllPalindromes(){
        List<String> list = new ArrayList<>();

        for (float i = 0; i < input.length(); i += .5) {


            float palindromeRadius = i - (int)i;


            while ((i + palindromeRadius) < input.length()
                    && (i - palindromeRadius) >= 0
                    && input.charAt((int)(i - palindromeRadius))
                    == input.charAt((int)(i + palindromeRadius))) {
                if( !list.contains(input.substring((int)(i - palindromeRadius),
                        (int)(i + palindromeRadius + 1)))) {
                    list.add(input.substring((int) (i - palindromeRadius),
                            (int) (i + palindromeRadius + 1)));
                }
                palindromeRadius++;
            }
        }

        return list.toArray(new String[0]);
    }

    public Boolean isPalindrome(){
        String clean = input.replaceAll("\\s+", "").toLowerCase();
        int length = clean.length();
        int forward = 0;
        int backward = length - 1;
        while (backward > forward) {
            char forwardChar = clean.charAt(forward++);
            char backwardChar = clean.charAt(backward--);
            if (forwardChar != backwardChar)
                return false;
        }
        return true;
    }

    public String reverseString(){
        String result = "";
        for (int i = input.length()-1; i>=0; i--) {
            result+= input.charAt(i);
        }
        return result;
    }
}
